<?php
/**
 * @version  3.1
 * @Project  Bookmarking Genius
 * @author   Bryan Keller
 * @package  
 * @copyright Copyright (C) 2011 Techheads IT Consulting. All rights reserved.
 * @license  http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL version 2
*/

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgContentBookmarkingGenius extends JPlugin {

  function plgContentBookmarkingGenius( &$subject,$params ) {
    parent::__construct( $subject,$params );
  }
 
  function onBeforeDisplayContent( &$article, &$params, $limitstart ) { 
    	$document 	= & JFactory::getDocument();
    	$view     	= JRequest::getCmd('view');
    	$position 	= $this->params->get('position','1');
	$embed 	= $this->params->get('embed', 'no');
   
    if ((($view == 'article')&&($this->params->get('viewonarticle')=='yes'))|| 
        (($view == 'frontpage')&&($this->params->get('viewonfrontpage')=='yes'))||
        (($view == 'category')&&($this->params->get('viewoncategory')=='yes'))||
        (($view == 'section')&&($this->params->get('viewonsection')=='yes'))
       ) { 
    	$title= htmlentities( $article->title, ENT_QUOTES, "UTF-8");
      $url = $this->getNewUrl($article);
      $htmlCode = $this->getArticleHTML($params, $article, $url, $title);


	if (($embed == 'yes') && (strstr($article->text, '{bookmarkinggenius}'))) {
			$article2 = $this->rstrstr($article->text, '{bookmarkinggenius}');
			$article2 .= $htmlCode;
			$article2 .= substr(strstr($article->text, '{bookmarkinggenius}'), 19);
			$article->text = $article2;
				}else{
      if ($position == '1'){
        $article->text =  $htmlCode . $article->text;  
      }
      if ($position == '2'){
        $article->text = $article->text . $htmlCode;
      }
      if ($position == '3'){
        $article->text =  $htmlCode . $article->text . $htmlCode;
      }
         }
 }else{
      return; 
    }
  }

  private function rstrstr($haystack,$needle)
    {
        return substr($haystack, 0,strpos($haystack, $needle));
    }
 
  private function  getArticleHTML($params, $article, $url, $title) { 
    	$ex_categories	= $this->params->get('ex_categories', '' );
    	$ex_articles	= $this->params->get('ex_articles', '' );
    	$ex_CatList	= @explode ( ",", $ex_categories ); 
    	$ex_ArticleList	= @explode ( ",", $ex_articles );  
    if ( in_array ( $article->id, $ex_ArticleList ) || in_array ( $article->catid, $ex_CatList ) ) return;
    	$size			= $this->params->get('size');
    	$css			= $this->params->get('css');
	$margin		= $this->params->get('margin', '2');
	$margin		= intval($margin);
	$text 		= $this->params->get('text','Bookmark this page on'); 
	$size2 	     	= intval($size) + intval($margin);
	$size3		= intval($size2) + 2;
	$effect		= $this->params->get('effect','none');
	$ssize		= intval($size) - 4;
	$ssizeoffset	= intval($size) - 2 + intval($margin);
	$gsize		= intval($size) + 4;
	$gsizeoffset	= intval($size) + 2 + intval($margin);
	$modcolor		= $this->params->get('modcolor','#ffffff');
	$shiftoffset	= intval($size) + intval($margin);
	$highlight		= $this->params->get('highlight','#fff000');
	$rotatedeg		= $this->params->get('rotatedeg',"90");
    	$htmlCode		= "";

$title2 = urlencode($title);


$bmarr = array("http://digg.com/submit?phase=2&amp;url=$url&amp;title=$title2", "http://www.facebook.com/sharer.php?u=$url&amp;t=$title2", "http://twitter.com/home?status=$url");

$titlarr = array("digg", "facebook", "twitter");

	$htmlCode = "";

			$htmlCode .= '<div style="' .$css. '">';

	for($i=0;$i < count($bmarr);$i++)
		{
			$ct="sb" . strval((intval($i) + 1));
			if ($this->params->get($ct, 'yes') == "yes")
				{
					$htmlCode .= '<a href='.$bmarr[$i].' target="_blank" rel="nofollow">';
					$htmlCode .= '<img style="width: '.$size.'px; height: '.$size.'px; margin:'. $margin .'px;" border="0" src="plugins/content/geniusicons/'.$titlarr[$i].'.png" alt='.$titlarr[$i].' title='.$titlarr[$i].' />';
					$htmlCode .= '</a>';

		switch ($effect) {
			case "none":
				break;
			case "custom":
					$htmlCode .= '<a href='.$bmarr[$i].' target="_blank" rel="nofollow">';
					$htmlCode .= '<img style="width: '.$size.'px; height: '.$size.'px; opacity:0.0;filter:alpha(opacity=0); position: relative; margin-bottom: '. $margin .'px; margin-left: -'. $size2 .'px; z-index: 2;" onmouseover="this.style.opacity=1;this.filters.alpha.opacity=100" onmouseout="this.style.opacity=0.0;this.filters.alpha.opacity=0" src="plugins/content/geniusicons/mo/'.$titlarr[$i].'.png" alt="'.$titlarr[$i].'" title="'. $text .' '.$titlarr[$i].'" />';
					$htmlCode .= '</a>';
				break;
			case "dogear":
					$htmlCode .= '<a href='.$bmarr[$i].' target="_blank" rel="nofollow">';
					$htmlCode .= '<img style="width: '.$size.'px; height: '.$size.'px; opacity:0.0;filter:alpha(opacity=0); position: relative; margin-bottom: '. $margin .'px; margin-left: -'. $size2 .'px; z-index: 2;" onmouseover="this.style.opacity=1;this.filters.alpha.opacity=100" onmouseout="this.style.opacity=0.0;this.filters.alpha.opacity=0" src="plugins/content/geniusicons/mo/dogear.png" alt="'.$titlarr[$i].'" title="'. $text .' '.$titlarr[$i].'" />';
					$htmlCode .= '</a>';
				break;
			case "shrink":
					$htmlCode .= '<a href='.$bmarr[$i].' target="_blank" rel="nofollow">';
					$htmlCode .= '<img style="width: '.$ssize.'px; height: '.$ssize.'px; opacity:0.0;filter:alpha(opacity=0); position: relative; margin-bottom: '. $margin .'px; border: 3px solid '. $modcolor .'; margin-left: -'. $size2 .'px; z-index: 4;" onmouseover="this.style.opacity=1;this.filters.alpha.opacity=100"
onmouseout="this.style.opacity=0.0;this.filters.alpha.opacity=0" src="plugins/content/geniusicons/'.$titlarr[$i].'.png" alt="'.$titlarr[$i].'" title="'. $text .' '.$titlarr[$i].'" />';
					$htmlCode .= '</a>';
				break;
			case "enlarge":
					$htmlCode .= '<a href='.$bmarr[$i].' target="_blank" rel="nofollow">';
					$htmlCode .= '<img style="width: '.$gsize.'px; height: '.$gsize.'px; opacity:0.0;filter:alpha(opacity=0); position: relative; margin-bottom: '. $margin .'px; margin-left: -'. $gsizeoffset .'px; z-index: 2;" onmouseover="this.style.opacity=1;this.filters.alpha.opacity=100" onmouseout="this.style.opacity=0.0;this.filters.alpha.opacity=0" src="plugins/content/geniusicons/'.$titlarr[$i].'.png" alt="'.$titlarr[$i].'" title="'. $text .' '.$titlarr[$i].'" />';
					$htmlCode .= '</a>';
				break;
			case "shiftup":
					$htmlCode .= '<a href='.$bmarr[$i].' target="_blank" rel="nofollow">';
					$htmlCode .= '<img style="width: '.$size.'px; height: '.$size.'px; opacity:0.0;filter:alpha(opacity=0); position: relative; margin-bottom: '. $margin .'px; border-bottom-style: solid; border-bottom-width: 3px; border-bottom-color: '. $modcolor .'; margin-left: -'. $shiftoffset .'px; z-index: 2;" onmouseover="this.style.opacity=1;this.filters.alpha.opacity=100"
onmouseout="this.style.opacity=0.0;this.filters.alpha.opacity=0" src="plugins/content/geniusicons/'.$titlarr[$i].'.png" alt="'.$titlarr[$i].'" title="'. $text .' '.$titlarr[$i].'" />';
					$htmlCode .= '</a>';
				break;
			case "highlight":
					$htmlCode .= '<a href='.$bmarr[$i].' target="_blank" rel="nofollow">';
					$htmlCode .= '<img style="width: '.$ssize.'px; height: '.$ssize.'px; opacity:0.0;filter:alpha(opacity=0); position: relative; margin-bottom: '. $margin .'px; border:2px solid '. $highlight .'; margin-left: -'. $size2 .'px; z-index: 4;" onmouseover="this.style.opacity=1;this.filters.alpha.opacity=100"
onmouseout="this.style.opacity=0.0;this.filters.alpha.opacity=0" src="plugins/content/geniusicons/'.$titlarr[$i].'.png" alt="'.$titlarr[$i].'" title="'. $text .' '.$titlarr[$i].'" />';
					$htmlCode .= '</a>';
				break;
			case "rotate":
					$htmlCode .= '<a href='.$bmarr[$i].' target="_blank" rel="nofollow">';
					$htmlCode .= '<img style="width: '.$size.'px; height: '.$size.'px; -moz-transform: rotate('.$rotatedeg.'deg); -ms-transform: rotate('.$rotatedeg.'deg); opacity:0.0;filter:alpha(opacity=0); position: relative; margin-bottom: '. $margin .'px; margin-left: -'. $size2 .'px; z-index: 2;" onmouseover="this.style.opacity=1;this.filters.alpha.opacity=100"
onmouseout="this.style.opacity=0.0;this.filters.alpha.opacity=0" src="plugins/content/geniusicons/'.$titlarr[$i].'.png" alt="'.$titlarr[$i].'" title="'. $text .' '.$titlarr[$i].'" />';
					$htmlCode .= '</a>';
				break;
			case "bullseye":
					$htmlCode .= '<a href='.$bmarr[$i].' target="_blank" rel="nofollow">';
					$htmlCode .= '<img style="width: '.$size.'px; height: '.$size.'px; opacity:0.0;filter:alpha(opacity=0); position: relative; margin-bottom: '. $margin .'px; margin-left: -'. $size2 .'px; z-index: 2;" onmouseover="this.style.opacity=1;this.filters.alpha.opacity=100" onmouseout="this.style.opacity=0.0;this.filters.alpha.opacity=0" src="plugins/content/geniusicons/mo/bullseye.png" alt="'.$titlarr[$i].'" title="'. $text .' '.$titlarr[$i].'" />';
					$htmlCode .= '</a>';
				break;
					}
			}
	}

			$htmlCode .= '</div>';

    return $htmlCode; 
  }
  
  private function getNewUrl($obj){
    if (!is_null($obj)) {
      $url = JRoute::_(ContentHelperRoute::getArticleRoute($obj->slug, $obj->catslug, $obj->sectionid));
      $uri = JURI::getInstance();
      $base  = $uri->toString( array('scheme', 'host', 'port'));
      $url = $base . $url;
      $url = JRoute::_($url, true, 0);
      return $url;
    }
  }
}
?>

